<?php

class actionCropperSave extends cmsAction {

    public function run(){

		if(!$this->request->isAjax()){ cmsCore::error404(); }
		if(!cmsForm::validateCSRFToken($this->request->get('csrf_token'))){ die('Error: 683552262'); }
		
		if(!$this->validate_slug($this->request->get('src'))){ die('Error: 1673883235'); }
		if(!$this->validate_slug($this->request->get('dest'))){ die('Error: 1673242735'); }
		
		$src = PATH.$this->cms_config->get('upload_root').$this->request->get('src');
		if(!file_exists($src)){ die('Error: 7287724343'); }
		
		$dest = PATH.$this->cms_config->get('upload_root').$this->request->get('dest');

		$preset_name = $this->request->get('preset_name');
		$presets = $this->model->getPresets();
		if(!array_key_exists($preset_name, $presets)){ die('Error: 724532873'); }
		$preset = $presets[$preset_name];

		$x = (int)$this->request->get('x');
		$y = (int)$this->request->get('y');
		$w = (int)$this->request->get('w');
		$h = (int)$this->request->get('h');
		$r = (int)$this->request->get('r');
		$sx = (int)$this->request->get('sx');
		$sy = (int)$this->request->get('sy');
		$quality = (int)$this->request->get('q');

		$image_params = img_get_params($src);
		if($image_params === false){ die('Error: 24127241245'); }

		$format = strtolower(substr($image_params['mime'], strpos($image_params['mime'], '/') + 1));
		$icfunc = 'imagecreatefrom'.$format;
		$igfunc = 'image'.$format;

		if(!function_exists($icfunc)){ die('Error: 745222272775412'); }
		if(!function_exists($igfunc)){ die('Error: 74227838737343'); }

		$isrc = $icfunc($src);
		
		if($r !== 0){
			$isrc = imagerotate($isrc, $r, 0);
			if(!$isrc){ die(); }
		}
		
		if($sx === -1) {
			imageflip($isrc, IMG_FLIP_HORIZONTAL);
		}
		
		if($sy === -1) {
			imageflip($isrc, IMG_FLIP_VERTICAL);
		}
		
		if($preset['width'] && $preset['height']){
			$new_width = $preset['width'];
			$new_height = $preset['height'];
		}elseif($preset['width'] && !$preset['height']){
			$new_width = $preset['width'];
			$new_height = $h / $w * $preset['width'];
		}elseif(!$preset['width'] && $preset['height']){
			$new_width = $w / $h * $preset['height'];
			$new_height = $preset['height'];
		}
		
		$idest = imagecreatetruecolor($new_width, $new_height);

		if($format == 'jpeg'){

			imagefill($idest, 0, 0, 0xFFFFFF);
			
		}elseif($format == 'png' || $format == 'gif'){
			
			$trans = imagecolorallocatealpha($idest, 255, 255, 255, 127);
			imagefill($idest, 0, 0, $trans);
			imagealphablending($idest, true);
			imagesavealpha($idest, true);
			
		}
		
		imagecopyresampled($idest, $isrc, 0, 0, $x, $y, $new_width, $new_height, $w, $h);
		
		if($format == 'jpeg'){
			imageinterlace($idest, 1);
		}
		if($format == 'png'){
			$quality = (10 - ceil($quality / 10));
		}
		if($format == 'gif'){
			$quality = NULL;
		}

		$igfunc($idest, $dest, $quality);
		imagedestroy($isrc);
		imagedestroy($idest);
		
		echo 'ok';
		die();

    }

}
