var icms = icms || {};

icms.images.uploadCallback = function(field_name, result){

	var widget = $('#widget_image_'+field_name);
	$('.btn-delete', widget).show();

	var udir = $('#cropper-edit-zone').attr('data-udir');

	for(var path in result.paths){
		if(path === 'original'){
			continue;
		}
		$('#widget_image_'+field_name+'_preview_'+path+' img', widget).attr('src', udir + result.paths[path].path);
	}
	
	return;
}

icms.images.removeCallback = function(field_name){
	var widget = $('#widget_image_'+field_name);
	$('.btn-delete', widget).hide();
	return;
}

icms.cropper = (function ($) {

    //====================================================================//
	
	this.edit = function(name, size){
		
		icms.modal.open('#cropper-edit-zone-templ');
		
		var el = $('#widget_image_'+name+'_preview_'+size);
		
		var w = +el.attr('data-w');
		var h = +el.attr('data-h');
		var c = +el.attr('data-c');
		var src = el.children('img').attr('src');
		
		var udir = $('#cropper-edit-zone').attr('data-udir');
		var full_img = $('#widget_image_'+name+' .data input[name = "'+name+'[original]"]').val();
		if(typeof full_img == 'undefined'){
			var full_img = $('#widget_image_'+name+' .data input[name = "'+name+'[big]"]').val();
		}
		if(typeof full_img == 'undefined'){
			var full_img = $('#widget_image_'+name+' .data input[name = "'+name+'['+size+']"]').val();
		}
		full_img = udir+full_img;
		
		$('#cropper-edit-zone .image').attr('src', full_img);
		
		$('#cropper-edit-zone').attr('data-name', name);
		$('#cropper-edit-zone').attr('data-size', size);
		$('#cropper-edit-zone').attr('data-c', c);
		
		var $image = $('#cropper-edit-zone .image');
		
		var $dataX = $('#cropper-edit-zone .dataX');
		var $dataY = $('#cropper-edit-zone .dataY');
		var $dataHeight = $('#cropper-edit-zone .dataHeight');
		var $dataWidth = $('#cropper-edit-zone .dataWidth');
		var $dataRotate = $('#cropper-edit-zone .dataRotate');
		var $dataScaleX = $('#cropper-edit-zone .dataScaleX');
		var $dataScaleY = $('#cropper-edit-zone .dataScaleY');
		
		var originalImageURL = $image.attr('src');
		var uploadedImageName = 'cropped.jpg';
		var uploadedImageType = 'image/jpeg';
		var uploadedImageURL;

		var options = {
			viewMode: 1,
			crop: function (e) {
				$dataX.val(Math.round(e.detail.x));
				$dataY.val(Math.round(e.detail.y));
				$dataHeight.val(Math.round(e.detail.height));
				$dataWidth.val(Math.round(e.detail.width));
				$dataRotate.val(e.detail.rotate);
				$dataScaleX.val(e.detail.scaleX);
				$dataScaleY.val(e.detail.scaleY);
			}
		};
		
		if(w > 0 && h > 0){
			options.aspectRatio = w / h;
		}

		$image.cropper(options);
		
		icms.modal.resize();
		
        icms.modal.setCallback('close', function(){
			$image.cropper('destroy');
        });

		if(typeof document.createElement('cropper').style.transition === 'undefined'){
			$('button[data-method="rotate"]').prop('disabled', true);
			$('button[data-method="scale"]').prop('disabled', true);
		}
		
		$('#cropper-edit-zone .docs-buttons').on('click', '[data-method]', function() {

			var $this = $(this);
			var data = $this.data();
			var cropper = $image.data('cropper');
			var cropped;
			var $target;
			var result;

			var name = $('#cropper-edit-zone').attr('data-name');
			var size = $('#cropper-edit-zone').attr('data-size');
			var auto = +$('#cropper-edit-zone').attr('data-auto');

			var el = $('#widget_image_'+name+'_preview_'+size);
			
			var w = +el.attr('data-w');
			var h = +el.attr('data-h');
			var n = +el.attr('data-n');
			var c = +el.attr('data-c');
			var src = el.children('img').attr('src');
			
			var nxt;

			if($this.prop('disabled') || $this.hasClass('disabled')){
				return;
			}

			if(cropper && data.method){
				data = $.extend({}, data); // Clone a new one

				if(typeof data.target !== 'undefined'){
					$target = $(data.target);

					if(typeof data.option === 'undefined'){
						try{
							data.option = JSON.parse($target.val());
						}catch(e){
							console.log(e.message);
						}
					}
				}

				cropped = cropper.cropped;

				switch(data.method){
					case 'rotate':
						if(cropped && options.viewMode > 0){
							$image.cropper('clear');
						}

					break;

					case 'getCroppedCanvas':
						if(uploadedImageType === 'image/jpeg'){
							if(!data.option){
								data.option = {};
							}

							data.option.fillColor = '#999';
						}

					break;
				}

				result = $image.cropper(data.method, data.option, data.secondOption);

				switch(data.method){
					case 'rotate':
						if(cropped && options.viewMode > 0){
							$image.cropper('crop');
						}

					break;

					case 'scaleX':
					case 'scaleY':
						$(this).data('option', -data.option);
					break;

					case 'getCroppedCanvas':
						if(result){
							// Фиксируем изменения
							var res = result.toDataURL(uploadedImageType);
							$('#widget_image_'+name+'_preview_'+size+' img').attr('src', res);

							var full_img = $('#widget_image_'+name+' .data input[name = "'+name+'[original]"]').val();
							if(typeof full_img == 'undefined'){
								var full_img = $('#widget_image_'+name+' .data input[name = "'+name+'[big]"]').val();
							}
							if(typeof full_img == 'undefined'){
								var full_img = $('#widget_image_'+name+' .data input[name = "'+name+'['+size+']"]').val();
							}
							
							var dest = $('#widget_image_'+name+' .data input[name = "'+name+'['+size+']"]').val();

							var d = {
								src: full_img,
								dest: dest,
								x: $('#cropper-edit-zone .dataX').val(),
								y: $('#cropper-edit-zone .dataY').val(),
								w: $('#cropper-edit-zone .dataWidth').val(),
								h: $('#cropper-edit-zone .dataHeight').val(),
								r: $('#cropper-edit-zone .dataRotate').val(),
								sx: $('#cropper-edit-zone .dataScaleX').val(),
								sy: $('#cropper-edit-zone .dataScaleY').val(),
								q: $('#widget_image_'+name+'_preview_'+size).attr('data-q'),
								preset_name: size,
								csrf_token: $('head meta[name = "csrf-token"').attr('content')
							};
							
							$.post('/cropper/save', d, function(res){
								if(res !== 'ok'){ console.log(res); }
							});
							
							icms.modal.close();
							
							nxt = n + 1;
							if(auto && c > nxt){
								$('#widget_image_'+name+'_preview_'+size+' .btn-edit-'+nxt).click();
							}else{
								$('#cropper-edit-zone').attr('data-auto', '0');
							}
						}

					break;
				}

				if ($.isPlainObject(result) && $target) {
					try {
						$target.val(JSON.stringify(result));
					} catch (e) {
						console.log(e.message);
					}
				}

			}

		});

	};

    //====================================================================//

	return this;

}).call(icms.crop || {},jQuery);